<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RCallStateMember StructType
 * @subpackage Structs
 */
class RCallStateMember extends AbstractStructBase
{
    /**
     * The callStateName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $callStateName;
    /**
     * The softKeys
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var SoftKeys
     */
    public $softKeys;
    /**
     * Constructor method for RCallStateMember
     * @uses RCallStateMember::setCallStateName()
     * @uses RCallStateMember::setSoftKeys()
     * @param string $callStateName
     * @param SoftKeys $softKeys
     */
    public function __construct($callStateName = null, SoftKeys $softKeys = null)
    {
        $this
            ->setCallStateName($callStateName)
            ->setSoftKeys($softKeys);
    }
    /**
     * Get callStateName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCallStateName()
    {
        return isset($this->callStateName) ? $this->callStateName : null;
    }
    /**
     * Set callStateName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $callStateName
     * @return RCallStateMember
     */
    public function setCallStateName($callStateName = null)
    {
        // validation for constraint: string
        if (!is_null($callStateName) && !is_string($callStateName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($callStateName)), __LINE__);
        }
        if (is_null($callStateName) || (is_array($callStateName) && empty($callStateName))) {
            unset($this->callStateName);
        } else {
            $this->callStateName = $callStateName;
        }
        return $this;
    }
    /**
     * Get softKeys value
     * @return SoftKeys|null
     */
    public function getSoftKeys()
    {
        return $this->softKeys;
    }
    /**
     * Set softKeys value
     * @param SoftKeys $softKeys
     * @return RCallStateMember
     */
    public function setSoftKeys(SoftKeys $softKeys = null)
    {
        $this->softKeys = $softKeys;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return RCallStateMember
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
